using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserCarts;
namespace CMSMicroservice.Protobuf.Validator.UserCarts;

public class UpdateUserCartRequestValidator : AbstractValidator<UpdateUserCartRequest>
{
    public UpdateUserCartRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Count)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserCartRequest>.CreateWithOptions((UpdateUserCartRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
